MODULE Files;

(* ---------------------------------------------------------------------------
 * (C) 2009 by Alexander Iljin
 * --------------------------------------------------------------------------- *)

IMPORT
   SYSTEM, Win:=Windows, Str;

TYPE
   (* The File should be made abstract when required *)
   File* = RECORD
      hnd*: Win.HANDLE;
   END;

VAR
   eol*: ARRAY 3 OF CHAR;

PROCEDURE (VAR f: File) Write* (VAR buff: ARRAY OF SYSTEM.BYTE; beg, end: LONGINT);
VAR tmp: Win.DWORD;
BEGIN
   IF Win.WriteFile (f.hnd, SYSTEM.VAL (Win.PCVOID, SYSTEM.ADR (buff [beg])), end - beg, tmp, NIL) THEN
   END;
END Write;

PROCEDURE (VAR f: File) Read* (VAR buff: ARRAY OF SYSTEM.BYTE; beg: LONGINT; VAR end: LONGINT);
VAR tmp: Win.DWORD;
BEGIN
   IF Win.ReadFile (f.hnd, SYSTEM.VAL (Win.PVOID, SYSTEM.ADR (buff [beg])), end - beg, tmp, NIL) THEN
      end := beg + SYSTEM.VAL (LONGINT, tmp);
   END;
END Read;

(* Tool procedures, can be moved to a different module *)

PROCEDURE WriteStr* (f: File; VAR str: ARRAY OF CHAR);
BEGIN
   f.Write (str, 0, Str.Length (str));
END WriteStr;

PROCEDURE WriteStrC* (f: File; str: ARRAY OF CHAR);
BEGIN
   WriteStr (f, str);
END WriteStrC;

PROCEDURE WriteChar* (f: File; ch: CHAR);
BEGIN
   f.Write (ch, 0, SIZE (CHAR));
END WriteChar;

PROCEDURE WriteInt* (f: File; int: LONGINT);
VAR
   s: ARRAY 11 OF CHAR;
   i: INTEGER;
   minus: BOOLEAN;
BEGIN
   i := LEN (s);
   IF int = 0 THEN
      DEC (i); s [i] := '0';
   ELSE
      minus := int < 0;
      IF minus THEN
         int := -int;
      END;
      WHILE int > 0 DO
         DEC (i); s [i] := CHR (ORD ('0') + (int MOD 10));
         int := int DIV 10;
      END;
      IF minus THEN
         DEC (i); s [i] := '-';
      END;
   END;
   f.Write (s, i, LEN (s));
END WriteInt;

PROCEDURE WriteLn* (f: File);
BEGIN
   f.Write (eol, 0, Str.Length (eol));
END WriteLn;

BEGIN
   eol := ''+0DX+0AX;
END Files.
