<*+main*> (* This marks the main module of a program or library.               *)
<*heaplimit="2000000"*> (* Maximum heap size should be set in the main module,
because the changes do not take effect until the main module is recompiled.    *)

MODULE Obide;

(* ---------------------------------------------------------------------------
 * (C) 2008 - 2010 by Alexander Iljin
 * --------------------------------------------------------------------------- *)

IMPORT
   NotepadPP, Npp, ObideVer, Main;--,Debug;

(* ---------------------------------------------------------------------------
 * This is the Oberon IDE plugin for Notepad++ (written in XDS Oberon).
 *
 * For the free XDS Modula-2/Oberon-2 compiler go to:
 *   http://www.excelsior-usa.com/xdsx86win.html
 *   (6.6 Mb to download, 17 Mb installed);
 * Oberon-2 is object-oriented programming language, both powerful and simple.
 * The full language report is only 20 pages long:
 *   http://europrog.ru/paper/oberon-2.pdf
 * It was created by prof. N.Wirth, author of Pascal and Modula. Some of his
 * publications:
 *   Programming in Oberon: http://europrog.ru/book/obnw2004e.pdf
 *   Compiler Construction: http://europrog.ru/book/ccnw2005e.pdf
 *   Project Oberon  The Design of an Operating System and Compiler:
 *     http://europrog.ru/book/ponw2005e.pdf
 * --------------------------------------------------------------------------- *)

PROCEDURE ['C'] About ();
(* Show info about this plugin. *)
BEGIN
   Main.About (NotepadPP.handle, Main.PluginName + ' ' + ObideVer.String);
END About;

PROCEDURE NppReady ();
(* This procedure is executed when Notepad++ has finished its startup. *)
BEGIN
   Main.NppReady (NotepadPP.scintillaMain, NotepadPP.scintillaSecond);
END NppReady;

PROCEDURE Init ();
VAR s: NotepadPP.Shortcut;
BEGIN
   (* Initialize the Npp interface module *)
   Npp.GetCurrentScintilla := NotepadPP.GetCurrentScintilla;
   Npp.GetPluginConfigDir := NotepadPP.GetPluginConfigDir;
   Npp.GetCurrentDir := NotepadPP.GetCurrentDir;
   Npp.GetFullCurrentPath := NotepadPP.GetFullCurrentPath;
   Npp.OpenFile := NotepadPP.OpenFile;
   (* Initialize the NotepadPP module *)
   NotepadPP.PluginName := Main.PluginName;
   NotepadPP.onReady := NppReady;
   NotepadPP.onSciNote := Main.ScintillaNotify;
   NEW (s);
   s.key := ' ';
   s.ctrl := TRUE;
   NotepadPP.AddMenuItem (Main.AutocompletionStr, Main.Autocompletion, FALSE, s);
   NEW (s);
   s.key := ' ';
   s.ctrl := TRUE;
   s.alt := TRUE;
   NotepadPP.AddMenuItem (Main.CodeHintStr, Main.CodeHint, FALSE, s);
   NEW (s);
   s.key := '9';
   s.ctrl := TRUE;
   NotepadPP.AddMenuItem (Main.GotoDeclarationStr, Main.GotoDeclaration, FALSE, s);
   NEW (s);
   s.key := '0';
   s.ctrl := TRUE;
   NotepadPP.AddMenuItem (Main.GoBackStr, Main.GoBack, FALSE, s);
   NEW (s);
   s.key := '-';
   s.ctrl := TRUE;
   NotepadPP.AddMenuItem (Main.GotoCompErrStr, Main.GotoCompErr, FALSE, s);
   NEW (s);
   s.key := '1';
   s.ctrl := TRUE;
   NotepadPP.AddMenuItem (Main.CompileStr, Main.Compile, FALSE, s);
   NotepadPP.AddMenuSeparator;
   NotepadPP.AddMenuItem (Main.AboutStr, About, FALSE, NIL)
END Init;

BEGIN Init
END Obide.
