# ============================================================================
# This file is part of GNUmakefile
# Some hidden rules (template rules) and internal variables are declared here
# to help you make your Amadeus project(s)
#
# The XDS/BIN directory should be in the PATH environment variable.
#

# ============================================================================
# Common rules for building Amadeus-based applications

include $(ROOT)/A3/Rules.make

.PHONY: dist

.PRECIOUS: %Ver.res

%Ver.ob2: %Ver %Ver.obt
	sed --file=$< -e "s/\.0';/';/" -e "s/\.0';/';/" < $<.obt > $@
# The additional regex removes two trailing zeroes from the version string.

%Ver.rc: %Ver %Ver.rct
	sed --file=$< < $<.rct > $@

%Ver.res: %Ver.rc
	gorc /r $<

%.dll: %.prj %Ver.res %Ver.ob2 $(ROOT)/Lib/*.ob2 *.ob2 $(ROOT)/A3/A3.dll
	xc =project $<
	-@echo off && mkdir obj 2> NUL
	-@echo off && mv *.obj *.sym tmp.lnk obj 2> NUL

# Distribution package

Obide.zip: Obide.dll ObideU.dll Doc/Changelog.txt Doc/Obide.txt Config/Obide.ini
	md Obide\Config
	cp $? Obide
	$(if $(filter Config/Obide.ini, $?), mv Obide/Obide.ini Obide/Config)
	zip -m -9 -r Obide Obide/*
	rd Obide

%.md5: %
	md5sum $< > $@

dist: Obide.zip.md5
	md5sum --check $<
